#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAX 32
#define MAX_CLASS 10
/* numero massimo di classi definibili in un file */


struct list_attr {
   int pblc;
   char *name_attr, *type_attr, *vector;
   struct list_attr *next;
};


struct list_attr_ered {
   char *name_attr_ered, *type_attr_ered, *vector_ered,*class_name_ered;
   struct list_attr_ered *next;
};


struct eredity {
   char *name;
   int tipo;
   struct eredity *succ;
};
 
/* il campo tipo indica il tipo di ereditarieta' della superclasse;
   in particolare : 1->private;            2->public; 
		    11->virtual private;  12->virtual public;
   Si e' deciso di memorizzare tale informazione soltanto per
   completezza; in realta' non ci sono controlli su di esso.
*/

struct classe {
   int exist_one_temporal;
   char *class_name;
   struct eredity *super_class;
   struct list_attr *list_not_temp, *temp_elem, *temp_punt;
   struct list_attr_ered *temp_ered_elem, *temp_ered_punt;
};


struct classe my_class[MAX_CLASS];
int num_class = 0, my_public;

/*---------------------------------------------------------------------------*/
int pointer_at_end(char *parola) {

   char ch;
   int i = 0, res = 0;
   
   while((ch = parola[i++]) != '\0') {
      if(ch == '*') {
	 parola[i - 1] = '\0';  
	 res++;
      }   
   }
   return(res);      
}

/*---------------------------------------------------------------------------*/
  void Insert_struct_date(FILE *out)
  { fprintf(out,"struct date { \n        int day, month, year; \n    };\n \n");
    fprintf(out,"int Current_time(date &valid); \n \n");
    fprintf(out,"int Date_Min_Eq( date x, date y) ; \n \n");
  }


/*---------------------------------------------------------------------------*/
int Separator2(char ch) {

   if((ch == ' ') || (ch == '\n') || (ch == '\t'))
      return(1);
   else
      return(0);
}
/*---------------------------------------------------------------------------*/
int Separator(char ch) {

   if(Separator2(ch) || (ch == ':') || (ch == ';') || (ch == ',') ||
			(ch == '(') || (ch == '[') || (ch == '{') ||
			(ch == ']') || (ch == '}'))
      return(1);
   else
      return(0);
}
/*---------------------------------------------------------------------------*/
char Get_Symbol(FILE *in, char *par) {

   int i = 0;
   char ch;

   strcpy(par, "");
   while(Separator(ch = getc(in)));
   if(ch == EOF)
      return(EOF);
   do
      par[i++] = ch;
   while(!Separator(ch = getc(in)) && (ch != EOF));
   par[i] = '\0';
   return(ch);
}
/*---------------------------------------------------------------------------*/
int Go_On(FILE *in, char ch) {
   
   if(ch == ',')
      return(1);
   if((ch == ';') || (ch == '{'))
     return(0);
   while(Separator2(ch = getc(in)));
   if(ch == ',')
      return(1);
   if((ch == ';') || (ch == '{'))
      return(0);
   return(0);
}
/*---------------------------------------------------------------------------*/
void Read_Single_Class(FILE *in) {

   char ch, *app = malloc(sizeof(char) * MAX);
   struct eredity *aux;
   int temptipo;
   do {
      temptipo = 0;
      aux = (struct eredity *) malloc(sizeof(struct eredity));
      ch = Get_Symbol(in, app);
      if (!strcmp(app,"virtual")) {
	  temptipo= temptipo + 10;
	  ch = Get_Symbol(in, app);
      }
      if (!strcmp(app,"private")) {
	  temptipo =temptipo + 1;
	  ch = Get_Symbol(in, app);
      } 
      if (!strcmp(app,"public")) {
	  temptipo =temptipo + 2;
	  ch = Get_Symbol(in, app);
      }
      
      aux->name =  malloc(sizeof(char) * MAX);
      strcpy(aux->name, app);
      
     
      aux->tipo = temptipo;
      aux->succ = my_class[num_class].super_class;
      my_class[num_class].super_class = aux;

   } while(Go_On(in, ch));
   aux = my_class[num_class].super_class;
/*   while(aux != NULL) {printf("aux->name%s\n",aux->name);
	aux = aux->succ;}
*/   
   free(app);
}
/*---------------------------------------------------------------------------*/
void Read_Super_Class(FILE *in, char ch) {

   if(ch != '{') {
      if(ch == ':') 
	 Read_Single_Class(in);
      else {
	 while(Separator2(ch = getc(in)));
	 if(ch == ':') 
	    Read_Single_Class(in);
      }
   }
}
/*---------------------------------------------------------------------------*/
void Read_Attrib(FILE *in, char *parola, int kind,int *attr_nome_classe) {

   struct list_attr *aux;
   char ch, *app = malloc(sizeof(char) * MAX);
   int i, num;

   if(!strcmp(parola, "struct") ||
      !strcmp(parola, "persistent")) {
      Get_Symbol(in, app);
      if ((kind) && !strcmp(app,my_class[num_class].class_name))
	    (*attr_nome_classe) = 1;
      strcat(parola, " ");
      strcat(parola, app);
   }
   do {
      aux = (struct list_attr *) malloc(sizeof(struct list_attr));
      aux->name_attr = malloc(sizeof(char) * MAX);
      aux->type_attr = malloc(sizeof(char) * MAX);
      aux->vector = malloc(sizeof(char) * MAX);
      strcpy(aux->vector, "");
      aux->pblc = my_public;

      num = pointer_at_end(parola);
      if(num)   
	 for(i = 0 ; i < num ; i++)
	    strcat(aux->vector, "*");
      strcpy(aux->type_attr, parola);
      ch = Get_Symbol(in, app);
      do {
	 i = num = 0;
	 while(app[i++] == '*') {
	    strcat(aux->vector, "*");
	    num++;
	 } 
	 if(num) {
	    if(app[i - 1] == '\0') 
	       ch = Get_Symbol(in, app);
	    else {
	       for(i = 1 ; i < MAX ; i++)
		  app[i - 1] = app[i - 1 + num];
	       num = 0;
	    }
	 }
      } while(num);
      strcpy(aux->name_attr, app);
      if(ch == '[') {
	 ch = Get_Symbol(in, app);
	 strcat(aux->vector, " ");
	 strcat(aux->vector, app);
      }   
      else
	 if((ch != ',') && (ch != ';')) {
	    while(Separator2(ch = getc(in)));
	    if(ch == '[') {
	       ch = Get_Symbol(in, app);
	       strcat(aux->vector, " ");
	       strcat(aux->vector, app);
	    }
	 }
      if(kind) {
	 if((!strcmp(aux->type_attr, "int") &&
	     !strcmp(aux->vector, "")) ||
	     (!strcmp(aux->type_attr, "char")) &&
	      (!strcmp(aux->vector, "") ||
	      ((aux->vector[0] == '*') &&
	      (aux->vector[1] == '\0')) ||
	      (aux->vector[0] == ' '))) {
	    aux->next = my_class[num_class].temp_elem;
	    my_class[num_class].temp_elem = aux;
	 }
	 else {
	    aux->next = my_class[num_class].temp_punt;
	    my_class[num_class].temp_punt = aux;
	    
	 }
      }
      else {
	 aux->next = my_class[num_class].list_not_temp;
	 my_class[num_class].list_not_temp = aux;
      }
   } while(Go_On(in, ch));
   free(app);
}
/*---------------------------------------------------------------------------*/
void Write_Single_Attr(FILE *out, struct list_attr *aux, int kind,int from) {

   char app[5];
  
   int i = 0;
   
   if(kind) 
      strcpy(app, "par_");
   else
      strcpy(app, "");

   fprintf(out, "%s ", aux->type_attr);
   if (from>=1) fprintf(out, "*"); 
   if(!strcmp(aux->vector, ""))
      fprintf(out, "%s%s", app, aux->name_attr);
   else {
      while(aux->vector[i++] == '*')
	 fprintf(out, "*");
      fprintf(out, "%s%s",app, aux->name_attr);
      if((from !=2)&&(aux->vector[i - 1] != '\0')) {
	 fprintf(out, "[");
	 while(aux->vector[i] != '\0')
	    fprintf(out, "%c", aux->vector[i++]);
	 fprintf(out, "]");
      }
   }
}
/*---------------------------------------------------------------------------*/
void Write_Single_Attr2(FILE *out, struct list_attr_ered *aux, int kind,int from) {

   char app[5];
  
   int i = 0;
   
   if(kind) 
      strcpy(app, "par_");
   else
      strcpy(app, "");

   fprintf(out, "%s ", aux->type_attr_ered);
   if (from>=1) fprintf(out, "*"); 
   if(!strcmp(aux->vector_ered, ""))
      fprintf(out, "%s%s", app, aux->name_attr_ered);
   else {
      while(aux->vector_ered[i++] == '*')
	 fprintf(out, "*");
      fprintf(out, "%s%s",app, aux->name_attr_ered);
      if((from !=2)&&(aux->vector_ered[i - 1] != '\0')) {
	 fprintf(out, "[");
	 while(aux->vector_ered[i] != '\0')
	    fprintf(out, "%c", aux->vector_ered[i++]);
	 fprintf(out, "]");
      }
   }
}
/*---------------------------------------------------------------------------*/
void Write_Struct(FILE *out, struct list_attr *aux) {

   while(aux) {
      fprintf(out, "struct _%s_%s {\n\t", aux->name_attr,
	       my_class[num_class].class_name);
      Write_Single_Attr(out, aux, 0,0);
      fprintf(out, ";\n\tdate valid_time;\n\tstruct _%s_%s *next;\n\t};\n\n",
		   aux->name_attr, my_class[num_class].class_name);
      aux = aux->next;
   }
}
/*---------------------------------------------------------------------------*/
void Write_Super_Class(FILE *out) {

   int flag = 0;
   struct eredity *aux = my_class[num_class].super_class;

   fprintf(out, ":");
   while(aux) {
      if(flag)
	 fprintf(out, ",");
/*        printf("%d in Write_Super_Class\n",aux->tipo);
*/
      if (aux->tipo==1) fprintf(out, " private");
      else  if (aux->tipo==2) fprintf(out, " public");
	    else if (aux->tipo==11) fprintf(out, " virtual private");
		 else fprintf(out, " virtual public");
       fprintf(out, " %s", aux->name);

      flag = 1;
      aux = aux->succ; 
   }
}
/*---------------------------------------------------------------------------*/
void Write_Private_Attrib(FILE *out) {

   struct list_attr *aux = my_class[num_class].list_not_temp;

   while(aux) {
      if(!aux->pblc) {
	 fprintf(out, "\t\t");
	 Write_Single_Attr(out, aux, 0,0);
	 fprintf(out, ";\n");
      }
      aux = aux->next;
   }

   aux = my_class[num_class].temp_elem;
   while(aux) {
      if(!aux->pblc) 
	 fprintf(out, "\t\tstruct _%s_%s *t_%s;\n", 
	 aux->name_attr,my_class[num_class].class_name, aux->name_attr);
      aux = aux->next;
   }
   
   aux = my_class[num_class].temp_punt;
   while(aux) {
      if(!aux->pblc) 
	 fprintf(out, "\t\tstruct _%s_%s *t_%s;\n",
	 aux->name_attr,my_class[num_class].class_name, aux->name_attr);
      aux = aux->next;
   }

}
/*---------------------------------------------------------------------------*/
void Write_Attrib(FILE *out, struct list_attr *aux, int kind) {

   while(aux) {
      if(aux->pblc) {
	 if(kind) 
	       fprintf(out, "\t\tstruct _%s_%s *t_%s;\n",
	       aux->name_attr,my_class[num_class].class_name, aux->name_attr);
	 else {
	    fprintf(out, "\t\t");
	    Write_Single_Attr(out, aux, 0,0);
	    fprintf(out, ";\n");
	 }
      }
      aux = aux->next;
   }
}
/*---------------------------------------------------------------------------*/
void Write_One_Body(FILE *out, struct list_attr *aux, int from) {
/*
se from=0 => write_body e' stata chiamata da write_construct
=> nome_var = temp_ 
se from=1 => write_body da insert_other_modify o insert_modify =>
nome_var = my_
*/
   char *app = malloc(sizeof(char) * MAX);
   char *nome_var = malloc(sizeof(char) * MAX);

   if(from) 
      strcpy(nome_var, "temp_");
   else  
      strcpy(nome_var, "t_");
   fprintf(out, "\n\t\t%s%s = (struct _%s_%s *) malloc(sizeof(struct _%s));",
   nome_var,aux->name_attr, aux->name_attr,my_class[num_class].class_name, aux->name_attr);
   
   if(app = strchr(aux->vector, ' ')) {
      fprintf(out, "\n\t\tfor(int i_%s=0;i_%s<%s;i_%s++)",
	      aux->name_attr,aux->name_attr,app,aux->name_attr);
      fprintf(out, "\n\t\t\t%s%s->%s[i_%s] = par_%s[i_%s];",nome_var,aux->name_attr,
	      aux->name_attr,aux->name_attr,aux->name_attr,aux->name_attr);
   }
   else
      fprintf(out, "\n\t\t%s%s->%s = par_%s;",
		   nome_var,aux->name_attr, aux->name_attr, aux->name_attr);
   fprintf(out, "\n\t\t%s%s->valid_time = aux_time;",
		nome_var,aux->name_attr);
   if(from) {
      fprintf(out, "\n\t\ttemp_%s->next = t_%s;\n",
		   aux->name_attr,aux->name_attr);
      fprintf(out, "\t\tt_%s = temp_%s;\n",
		   aux->name_attr,aux->name_attr);
   }
   else
      fprintf(out, "\n\t\tt_%s->next = NULL;\n", aux->name_attr);
   free(nome_var);
   
      free(app);
}
/*---------------------------------------------------------------------------*/
void Write_One_Body2(FILE *out, struct list_attr_ered *aux, int from) {
/*
se from=0 => write_body e' stata chiamata da write_construct
=> nome_var = temp_ 
se from=1 => write_body da insert_other_modify o insert_modify =>
nome_var = t_
*/
   char *app = malloc(sizeof(char) * MAX);
   char *nome_var = malloc(sizeof(char) * MAX);

   if(from) 
      strcpy(nome_var, "temp_");
   else  
      strcpy(nome_var, "t_");
   fprintf(out, "\n\t\t%s%s = (struct _%s_%s *) malloc(sizeof(struct _%s));",
		 nome_var,aux->name_attr_ered, aux->name_attr_ered,
		 aux->class_name_ered, aux->name_attr_ered);
   
   if(app = strchr(aux->vector_ered, ' ')) {
      fprintf(out, "\n\t\tfor(int i_%s=0;i_%s<%s;i_%s++)",
	      aux->name_attr_ered,aux->name_attr_ered,app,aux->name_attr_ered);
      fprintf(out, "\n\t\t\t%s%s->%s[i_%s] = par_%s[i_%s];",nome_var,aux->name_attr_ered,
	      aux->name_attr_ered,aux->name_attr_ered,aux->name_attr_ered,aux->name_attr_ered);
   }
   else
      fprintf(out, "\n\t\t%s%s->%s = par_%s;",
		   nome_var,aux->name_attr_ered, aux->name_attr_ered, aux->name_attr_ered);
   fprintf(out, "\n\t\t%s%s->valid_time = aux_time;",
		nome_var,aux->name_attr_ered);
   if(from) {
      fprintf(out, "\n\t\ttemp_%s->next = t_%s;\n",
		   aux->name_attr_ered,aux->name_attr_ered);
      fprintf(out, "\t\tt_%s = temp_%s;\n",
		   aux->name_attr_ered,aux->name_attr_ered);
   }
   else
      fprintf(out, "\n\t\tt_%s->next = NULL;\n", aux->name_attr_ered);
   free(nome_var);
   
      free(app);
}
/*---------------------------------------------------------------------------*/
void Write_Body(FILE *out, struct list_attr *aux, int from) {
/* mettere il ciclo direttamente al posto della chiamata della procedura */
   
   while(aux) {
      Write_One_Body(out,aux,from);
      aux = aux->next;
   }

}
/*---------------------------------------------------------------------------*/
void Write_Body2(FILE *out, struct list_attr_ered *aux, int from) {
/* mettere il ciclo direttamente al posto della chiamata della procedura */
   
   while(aux) {
      Write_One_Body2(out,aux,from);
      aux = aux->next;
   }

}
/*---------------------------------------------------------------------------*/
void Write_Construct(FILE *in, FILE *out) {

   char car;
   int flag = -1;
   struct list_attr *aux = my_class[num_class].temp_elem; 
   struct list_attr_ered *aux1;
   int with_par = 1;  //il costruttore ha paramentri
   fprintf(out, "\t\t%s(", my_class[num_class].class_name);
   while (Separator2(car = getc(in)))       fputc(car,out);
   if (car==')') with_par = 0;
   fputc(car, out);
   if (with_par == 1) {    /*il costruttore ha parametri*/
   
/* printf("siamo in write_construct\n");
*/
   FILE *support;  
   if (( support = fopen("support.c","w")) == NULL)
     { fprintf(stderr,"fopen del file di supporto fallita \n");
       return;
     }
   fputc(car, support);
   while(((car = getc(in)) != '}') || flag) {
       fputc(car, out);
       fputc(car, support);
       if(car == '{')
	  flag++;
       if(car == '}')
	  flag--;
    } 
    
     aux = my_class[num_class].temp_elem;
     while(aux) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux->name_attr);
	aux = aux->next;
     }
     aux1 = my_class[num_class].temp_ered_elem;
     while(aux1) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux1->name_attr_ered);
	aux1 = aux1->next;
     }
     aux = my_class[num_class].temp_punt;
     while(aux) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux->name_attr);
	aux = aux->next;
     }
     aux1 = my_class[num_class].temp_ered_punt;
     while(aux1) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux1->name_attr_ered);
	aux1 = aux1->next;
     }
   fprintf(out, "}");
   fclose(support);
   if (( support = fopen("support.c","r")) == NULL)
     { fprintf(stderr,"fopen del file di supporto fallita \n");
       return;
     }
    
  fprintf(out, "\n\t\t%s(", my_class[num_class].class_name); 
  while ((car = getc(support)) != ')') fputc(car, out);
    fprintf(out, ",");
    aux = my_class[num_class].temp_elem;
    while(aux) {
       Write_Single_Attr(out,aux,1,0);
       fprintf(out, ",");
       aux = aux->next;
    }
    
    aux1 = my_class[num_class].temp_ered_elem;
    while(aux1) {           
    Write_Single_Attr2(out,aux1,1,0);
       fprintf(out, ",");
       aux1 = aux1->next;
    }
    aux = my_class[num_class].temp_punt;
    while(aux) {
       Write_Single_Attr(out,aux,1,0);
       fprintf(out, ",");
       aux = aux->next;
    }
    aux1 = my_class[num_class].temp_ered_punt;
    while(aux1) {
    Write_Single_Attr2(out,aux1,1,0);
       fprintf(out, ",");
       aux1 = aux1->next;
    }
    fprintf(out, "date time)");
    while ((car  = getc(support))!= EOF)  fputc(car, out);
    fclose(support);
    }
    if (with_par == 0) {
    flag = -1;  
    while(((car = getc(in)) != '}') || flag) {
       fputc(car, out);
       if(car == '{')
	  flag++;
       if(car == '}')
	  flag--;
    }
     aux = my_class[num_class].temp_elem;
     while(aux) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux->name_attr);
	aux = aux->next;
     }
     aux1 = my_class[num_class].temp_ered_elem;
     while(aux1) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux1->name_attr_ered);
	aux1 = aux1->next;
     }
     aux = my_class[num_class].temp_punt;
     while(aux) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux->name_attr);
	aux = aux->next;
     }
     aux1 = my_class[num_class].temp_ered_punt;
     while(aux1) {
	fprintf(out, "\n\t\tt_%s = NULL;", aux1->name_attr_ered);
	aux1 = aux1->next;
     }
    } 
    else { 
   fprintf(out, "  \n\t\tdate aux_time;"); 
   fprintf(out, "\n\n\t\tif(time.day == 0)\n\t\t\tCurrent_time(aux_time);");
   fprintf(out, "\n\t\telse\n\t\t\taux_time = time;\n");
   Write_Body(out, my_class[num_class].temp_elem,0);
   Write_Body2(out, my_class[num_class].temp_ered_elem,0);
   Write_Body(out, my_class[num_class].temp_punt,0);
   Write_Body2(out, my_class[num_class].temp_ered_punt,0);
   }
   fprintf(out, "\n\t\tis_dead.day=0;is_dead.month=0;is_dead.year=0;\n\t\t}\n");
}
/*---------------------------------------------------------------------------*/
void Write_Delete(FILE *out, struct list_attr *aux) {

   char *app = malloc(sizeof(char) * MAX);
   char ch;
   while(aux) {
      if (!strncmp(aux->type_attr,"persistent",10)) ch = 'p';
      else ch=' ';
      fprintf(out, "\n\t\tstruct _%s_%s *aux_%s = t_%s;",
 aux->name_attr,my_class[num_class].class_name, aux->name_attr, aux->name_attr);
      fprintf(out, "\n\t\twhile(aux_%s) {", aux->name_attr);
      fprintf(out, "\n\t\t\tt_%s = t_%s->next;",
		   aux->name_attr, aux->name_attr);
      if(aux->vector[0] == '*') {
	 if(app=strchr(aux->vector, ' ')) {
	    fprintf(out, "\n\t\t\tint i;\n\t\t\tfor(i=0;i<%s;i++)", app);
	    fprintf(out, "\n\t\t\t\t%cdelete(aux_%s->%s[i]);",
			 ch,aux->name_attr, aux->name_attr);
	 }
	 else
	    fprintf(out, "\n\t\t\t%cdelete(aux_%s->%s);",
			ch, aux->name_attr, aux->name_attr);
      }
      fprintf(out, "\n\t\t\tdelete(aux_%s);", aux->name_attr);
      fprintf(out, "\n\t\t\taux_%s = t_%s;\n\t\t}\n",
		   aux->name_attr, aux->name_attr);
      aux = aux->next;
   }
  
      free(app);
}
/*---------------------------------------------------------------------------*/
void Write_Delete2(FILE *out, struct list_attr_ered *aux) {

   char *app = malloc(sizeof(char) * MAX);
   char ch;
   while(aux) {
      if (!strncmp(aux->type_attr_ered,"persistent",10)) ch = 'p';
      else ch=' ';
      fprintf(out, "\n\t\tstruct _%s_%s *aux_%s = t_%s;",
	      aux->name_attr_ered, aux->class_name_ered,
	      aux->name_attr_ered, aux->name_attr_ered);
      fprintf(out, "\n\t\twhile(aux_%s) {", aux->name_attr_ered);
      fprintf(out, "\n\t\t\tt_%s = t_%s->next;",
		   aux->name_attr_ered, aux->name_attr_ered);
      if(aux->vector_ered[0] == '*') {
	 if(app=strchr(aux->vector_ered, ' ')) {
	    fprintf(out, "\n\t\t\tint i;\n\t\t\tfor(i=0;i<%s;i++)", app);
	    fprintf(out, "\n\t\t\t\t%cdelete(aux_%s->%s[i]);",
			 ch,aux->name_attr_ered, aux->name_attr_ered);
	 }
	 else
	    fprintf(out, "\n\t\t\t%cdelete(aux_%s->%s);",
			ch, aux->name_attr_ered, aux->name_attr_ered);
      }
      fprintf(out, "\n\t\t\tdelete(aux_%s);", aux->name_attr_ered);
      fprintf(out, "\n\t\t\taux_%s = t_%s;\n\t\t}\n",
		   aux->name_attr_ered, aux->name_attr_ered);
      aux = aux->next;
   }
  
      free(app);
}
/*---------------------------------------------------------------------------*/
void Write_Distruct(FILE *in, FILE *out) {

   char ch;
   int flag = -1;

   fprintf(out, "\t\t~%s(", my_class[num_class].class_name);
   while(((ch = getc(in)) != '}') || flag) {
      fputc(ch, out);
      if(ch == '{')
	 flag++;
      if(ch == '}')
	 flag--;
   }
   Write_Delete(out, my_class[num_class].temp_elem);
   Write_Delete2(out, my_class[num_class].temp_ered_elem);
   Write_Delete(out, my_class[num_class].temp_punt);
   Write_Delete2(out, my_class[num_class].temp_ered_punt);
   fprintf(out, "\n\t\t}\n");
}
/*---------------------------------------------------------------------------*/
void check_life(FILE *out)

  {
    fprintf (out,"\t\tif (is_dead.day!=0)\n");
    fprintf (out,"\t\t{ cout<<\"Non e' possibile modificare l'oggetto \"\n");
    fprintf (out,"\t\t<<\"poiche' e' stato cancellato dalla base di dati\"<<endl;\n");
    fprintf (out,"\t\treturn;\n\t\t}\n");
  }
/*---------------------------------------------------------------------------*/
void Insert_Modify(FILE *out) {

   struct list_attr *aux = my_class[num_class].temp_elem;
   struct list_attr_ered *aux1 = my_class[num_class].temp_ered_elem;    
   int j = 1, k = 1;
   if ((aux==NULL)&&(aux1==NULL)) return;
   fprintf(out, "\tvoid modify(date time) {");
   fprintf(out, "\n\t\tint x;\n");
   check_life(out);
   fprintf(out, "\t\tcout << \" quale attributo modificare? \" ; \n");
   fprintf(out, "\t\tcout <<\" ");
   
   
   while(aux) {
      fprintf(out, "%s", aux->name_attr);
      fprintf(out, " -> %d ",j++);
      aux = aux->next;
   }
   while(aux1) {
      fprintf(out, "%s", aux1->name_attr_ered);
      fprintf(out, " -> %d ",j++);
      aux1 = aux1->next;
   }
   fprintf(out, " \" ;\n");
   fprintf(out, "\t\t cin >> x;\n ");
   fprintf(out, "\t\tdate aux_time;");
   fprintf(out, "\n\t\tif(time.day == 0)\n\t\t\tCurrent_time(aux_time);");
   fprintf(out, "\n\t\telse\n\t\t\taux_time = time;\n");
  
   fprintf(out, "\t\tswitch (x) { \n");
   aux = my_class[num_class].temp_elem;
     while(aux) {
	fprintf(out, "\t case  %d : \n\t\t{\n",k++);
	
	fprintf(out, "\t\tif(!Date_Min_Eq(aux_time,t_%s)) {\n",
		aux->name_attr);                
	fprintf(out, "\n\t\tcout <<  \"Inserire nuovo valore \";\n");  

	fprintf(out, "\t\tstruct _%s_%s *temp_%s;\n\t\t",
	aux->name_attr,my_class[num_class].class_name, aux->name_attr);
	Write_Single_Attr(out, aux, 1,0);
	if(aux->vector[0]  == '*')
	   fprintf(out, ";\n\t\tpar_%s = new %s[32]",
		      aux->name_attr , aux->type_attr);
	fprintf(out, ";\n\t\tcin >> par_%s;",aux->name_attr);
	Write_One_Body(out,aux,1);
	fprintf(out, "\t\t}\n\t\telse {\n");  
	fprintf(out, "\t\tcout << \"Non e' possibile effettuare \"\n");      
	fprintf(out, "\t\t<< \"l'aggiornamento dell'attributo\"\n");     
	fprintf(out, "\t\t<< %s <<\"poiche' la data di tale operazione \"\n",
		      aux->name_attr);   
	fprintf(out, "\t\t<< \"e' successiva alla data relativa al valore \"\n");   
	fprintf(out, "\t\t<< \"piu' recente dell'attributo nel dbase \"\n");
	fprintf(out, "\t\t<< endl;\n\t\t}");   
	
	fprintf(out, "\n\t\tbreak;\n\t\t}\n");
	aux = aux->next;
     }
   aux1 = my_class[num_class].temp_ered_elem;
   while(aux1) {
	fprintf(out, "\t case  %d : \n\t\t{\n",k++);

	fprintf(out, "\t\tif(!Date_Min_Eq(aux_time,t_%s)) {\n",
		aux1->name_attr);                
	fprintf(out, "\n\t\tcout <<  \"Inserire nuovo valore \";\n");  

	fprintf(out, "struct _%s_%s *temp_%s;\n\t\t",
		aux1->name_attr_ered,aux1->class_name_ered, 
		aux1->name_attr_ered);
	Write_Single_Attr2(out, aux1, 1,0);
	if(aux1->vector_ered[0]  == '*')
	   fprintf(out, ";\n\t\tpar_%s = new %s[32]",
		      aux1->name_attr_ered , aux1->type_attr_ered);
	fprintf(out, ";\n\t\tcin >> par_%s;",aux1->name_attr_ered);
	Write_One_Body2(out,aux1,1);
	fprintf(out, "\t\t}\n\t\telse {\n");  
	fprintf(out, "\t\tcout << \"Non e' possibile effettuare \"\n");      
	fprintf(out, "\t\t<< \"l'aggiornamento dell'attributo\"\n");     
	fprintf(out, "\t\t<< %s <<\"poiche' la data di tale operazione \"\n",
		      aux1->name_attr);   
	fprintf(out, "\t\t<< \"e' successiva alla data relativa al valore \"\n");   
	fprintf(out, "\t\t<< \"piu' recente dell'attributo nel dbase \"\n");
	fprintf(out, "\t\t<< endl;\n\t\t}");   
	fprintf(out, "\n\t\tbreak;\n\t\t}\n");
	
	aux1 = aux1->next;
     }
   
   fprintf(out, "\t } \n");
   fprintf(out, "\t} \n");
}
/*---------------------------------------------------------------------------*/
void Insert_Other_Modify(FILE *out) {

   struct list_attr *aux = my_class[num_class].temp_punt;

   while (aux) {
     fprintf  (out,"\n\tvoid modify_%s(date time,",aux->name_attr);

     Write_Single_Attr(out,aux,1,0);
     fprintf  (out,") {\n");
     fprintf  (out,"\t\tstruct _%s_%s *temp_%s;\n",
     aux->name_attr,my_class[num_class].class_name, aux->name_attr);
     check_life(out);
     fprintf(out, "\t\tdate aux_time;");
     fprintf(out, "\n\t\tif(time.day == 0)\n\t\t\tCurrent_time(aux_time);");
     fprintf(out, "\n\t\telse\n\t\t\taux_time = time;\n");
     
     fprintf(out, "\t\tif(!Date_Min_Eq(aux_time,t_%s)) {",
		  aux->name_attr);                
     Write_One_Body(out,aux,1);
     
     fprintf(out, "\t\t}\n\t\telse {\n");  
     fprintf(out, "\t\tcout << \"Non e' possibile effettuare \"\n");      
     fprintf(out, "\t\t<< \"l'aggiornamento dell'attributo\"\n");     
     fprintf(out, "\t\t<< %s <<\"poiche' la data di tale operazione \"\n",
		  aux->name_attr);   
     fprintf(out, "\t\t<< \"e' successiva alla data relativa al valore \"\n");   
     fprintf(out, "\t\t<< \"piu' recente dell'attributo nel dbase \"\n");
     fprintf(out, "\t\t<< endl;\n\t\t}");   
 
     fprintf(out,"\n\t\t} \n");
     aux = aux->next;

   }
}
/*---------------------------------------------------------------------------*/
void Insert_Show(FILE *out) {
 int j = 1,k=1;
 struct list_attr *aux = my_class[num_class].temp_elem; 
 struct list_attr_ered *aux1 = my_class[num_class].temp_ered_elem;       
 if ((aux==NULL)&&(aux1==NULL)) return;
 fprintf(out,"\n\tint show(date time)  {\n\t\t int x;\n");
 fprintf(out,"\t\tif (is_dead.day!=0)\n");
 fprintf(out,"\t\tif (Date_Min_Eq(is_dead,time)==1)\n\t\t{");
     /*si puo' omettere ==1*/
 fprintf(out,"\n\t\"cout<<\"L'oggetto e' stato cancellato in data:\"\n");
 fprintf(out,"\t\t<< is_dead.day << \"/\" \n");
 fprintf(out,"\t\t<< is_dead.month << \"/\" \n");
 fprintf(out,"\t\t<< is_dead.year <<endl;\n");
 fprintf(out,"\t\treturn 0;\n\t\t}\n");
 fprintf(out,"\t\tcout <<\"quale attributo si vuole esaminare?\";\n");
 fprintf(out,"\t\tcout <<\" ");
 
 while (aux != NULL)          /*si puo' omettere !=NULL*/
   {  fprintf(out, "%s", aux->name_attr);
      fprintf (out," -> %d ",j++);
      aux = aux->next;
   }
 
 while (aux1 != NULL)          /*si puo' omettere !=NULL*/
   {  fprintf(out, "%s", aux1->name_attr_ered);
      fprintf (out," -> %d ",j++);
      aux1 = aux1->next;
   }
 fprintf(out," \" ;\n");
 fprintf(out,"\t\tcin >> x;\n ");

 fprintf(out,"\t\tswitch (x) { \n");
 aux = my_class[num_class].temp_elem;
   while (aux != NULL)
    { fprintf(out,"\tcase  %d : \n\t\t{\n",k++);
      fprintf(out,"\t\tstruct _%s_%s *temp_%s = t_%s;\n\t\t",
	      aux->name_attr, aux->class_name_ered, 
	      aux->name_attr,aux->name_attr);
      fprintf(out,"while (temp_%s!=NULL)\n\t\t{\n",
	    aux->name_attr);
      fprintf(out,"\t\tif (Date_Min_Eq(temp_%s->valid_time,time)==1) {\n",
	    aux->name_attr);
     
      fprintf(out,"\t\tcout << \" %s =\" << temp_%s->%s << endl;\n ",
	      aux->name_attr,aux->name_attr,aux->name_attr);
      fprintf(out,"\t\treturn 1;\n\t\t}\n");
      fprintf(out,"\t\telse temp_%s = temp_%s->next;\n",
	      aux->name_attr, aux->name_attr);
      fprintf(out,"\t\t}\n\t\tbreak;\n\t\t}\n");        
      aux = aux->next;
    }
 aux1 = my_class[num_class].temp_ered_elem; 
  while (aux1 != NULL)
    { fprintf(out,"\tcase  %d : \n\t\t{\n",k++);
      fprintf(out,"\t\tstruct _%s_%s *temp_%s = t_%s;\n\t\t",
 aux1->name_attr_ered,my_class[num_class].class_name, aux1->name_attr_ered,aux1->name_attr_ered);
      fprintf(out,"while (temp_%s!=NULL)\n\t\t{\n",
	    aux1->name_attr_ered);
      fprintf(out,"\t\tif (Date_Min_Eq(temp_%s->valid_time,time)==1) {\n",
	    aux1->name_attr_ered);
      
      fprintf(out,"\t\tcout << \" %s =\" << temp_%s->%s << endl;\n ",
	      aux1->name_attr_ered,aux1->name_attr_ered,aux1->name_attr_ered);
      fprintf(out,"\t\treturn 1;\n\t\t}\n");
      fprintf(out,"\t\telse temp_%s = temp_%s->next;\n",
	      aux1->name_attr_ered, aux1->name_attr_ered);
      fprintf(out,"\t\t}\n\t\tbreak;\n\t\t}\n");        
      aux1 = aux1->next;
    }
 fprintf(out,"\t\t}\n");
 fprintf(out,"\t\tcout <<\"L'oggetto, in data: \"\n");
 fprintf(out,"\t\t<< time.day << \"/\"");
 fprintf(out,"<< time.month << \"/\"");
 fprintf(out,"<< time.year \n");
 fprintf(out,"\t\t<<\", non era ancora presente nel dbase\"<< endl;\n");  
 fprintf(out,"\n\t\treturn 0;\n\t\t}");

}
/*---------------------------------------------------------------------------*/
void Insert_Delete(FILE *out) {
      fprintf  (out,"\n\tvoid delete_object(date time) { \n");
      check_life(out);
      fprintf(out, "\t\tif(time.day == 0)\n\t\t\tCurrent_time(is_dead);");
      fprintf(out, "\n\t\telse\n\t\t\tis_dead = time;");
      fprintf  (out,"\n\t\t}\n");
}
/*---------------------------------------------------------------------------*/
void Insert_Find(FILE *out) {

 struct list_attr *aux = my_class[num_class].temp_punt;
 char *app = malloc(sizeof(char) * MAX);
 while(aux) {
    fprintf  (out,"\n\n\tint find_%s(date time,",aux->name_attr);
    if (strchr(aux->vector,' ')!= NULL)
     Write_Single_Attr(out,aux,1,2);
    else Write_Single_Attr(out,aux,1,1);
    fprintf  (out,")\n\t\t{\n");
    fprintf(out,"\t\tif (is_dead.day!=0)\n");
    fprintf(out,"\t\tif (Date_Min_Eq(is_dead,time))  {");
    fprintf(out,"\n\t\tcout<<\"L'oggetto e' stato cancellato in data:\"\n");
    fprintf(out,"\t\t<< is_dead.day << \"/\" \n");
    fprintf(out,"\t\t<< is_dead.month << \"/\" \n");
    fprintf(out,"\t\t<< is_dead.year <<endl;\n");
    fprintf(out,"\t\treturn 0;  }\n");
  
    fprintf(out,"\t\tstruct _%s_%s *temp_%s = t_%s;\n\t\t",
aux->name_attr,my_class[num_class].class_name, aux->name_attr,aux->name_attr);
    fprintf(out,"while (temp_%s!=NULL)\n\t\t{\n",
		aux->name_attr);
    fprintf(out,"\t\tif (Date_Min_Eq(temp_%s->valid_time,time)) {\n",aux->name_attr);
     
    if(app = strchr(aux->vector, ' ')) {  
       fprintf(out, "\n\t\tfor(int i=0;i<%s;i++) ", app);
       fprintf(out, "\n\t\t\t(*par_%s++) = temp_%s->%s[i];",
       aux->name_attr, aux->name_attr,aux->name_attr);
       }
    else
      fprintf(out, "\n\t\t(*par_%s) = temp_%s->%s;",
		   aux->name_attr, aux->name_attr, aux->name_attr);
    fprintf(out,"\n\t\treturn 1;\n\t\t}\n");
    fprintf(out,"\t\telse temp_%s = temp_%s->next;\n",
		aux->name_attr, aux->name_attr);
    fprintf(out,"\t\t}\n");
    fprintf(out,"\t\tcout <<\"L'oggetto, in data: \"\n");
    fprintf(out,"\t\t<< time.day << \"/\"");
    fprintf(out,"<< time.month << \"/\"");
    fprintf(out,"<< time.year \n");
    fprintf(out,"\t\t<<\", non era ancora presente nel dbase\"<< endl;\n");  
    fprintf(out,"\n\t\treturn 0;\n\t\t}");
  aux = aux->next;
  }
  free(app);
}
/*---------------------------------------------------------------------------*/
void Construct_Methods(FILE *out) {

   
   Insert_Modify(out);
   Insert_Other_Modify(out);
   Insert_Show(out);
   Insert_Find(out);
   Insert_Delete(out);
} 
/*---------------------------------------------------------------------------*/
void Dealloca_Liste(struct list_attr *aux) {

   struct list_attr *app;

   while(aux) {
      app = aux->next;
      free(aux->name_attr);
      free(aux->type_attr);
      free(aux->vector);
      delete(aux);
      aux = app;
   }
}
/*---------------------------------------------------------------------------*/
void Dealloca_Liste1(struct eredity *aux) {

   struct eredity *app;

   while(aux) {
      app = aux->succ;
      free(aux->name);
      delete(aux);
      aux = app;
   }
}
/*---------------------------------------------------------------------------*/
void Dealloca_Liste2(struct list_attr_ered *aux) {

   struct list_attr_ered *app;

   while(aux) {
      app = aux->next;
      free(aux->name_attr_ered);
      free(aux->type_attr_ered);
      free(aux->vector_ered);
      free(aux->class_name_ered);
      delete(aux);
      aux = app;
   }
}
/*---------------------------------------------------------------------------*/
int Ind_From_Class(char *nome) {
    int i=0,flag = 1;
    while (flag)
       if (!strcmp(my_class[i].class_name,nome))
	  flag = 0;
       else i++;
    return (i);
}
/*---------------------------------------------------------------------------*/
int Control_S_classe(char *name_class,char *attrib,char *class_stop) {
    int res = 0,ind;
    list_attr *aux; eredity *temp;
    if (!strcmp(name_class,class_stop)) return (res);
    ind = Ind_From_Class(name_class);
    aux = my_class[ind].list_not_temp;
    while (aux && !res) {
     if(!strcmp(aux->name_attr,attrib))
       res =1;
     aux=aux->next;
    }
    temp=my_class[ind].super_class;
    while(temp && !res) {
     res=Control_S_classe(temp->name,attrib,class_stop);
     temp=temp->succ;
    }
    return(res);
}
/*---------------------------------------------------------------------------*/
int Control_Eredity() {
    int res = 0;
    list_attr_ered *aux=my_class[num_class].temp_ered_elem;
    while (aux && !res) {
     res=Control_S_classe(my_class[num_class].class_name,
     aux->name_attr_ered,aux->class_name_ered);
     aux=aux->next;
    }
    aux=my_class[num_class].temp_ered_punt;
    while (aux && !res) {
     res=Control_S_classe(my_class[num_class].class_name,aux->name_attr_ered,aux->class_name_ered);
     aux=aux->next;
    }
    return(res);
}
/*---------------------------------------------------------------------------*/
int Not_Exists(struct list_attr_ered *aux,char *nome,char *classe) {
    int flag=1,res=1;
    struct list_attr_ered *app=aux;
    while(app && flag) {
     if (!strcmp(app->name_attr_ered,nome)) {
	flag=0;res=0;
	if (strcmp(app->class_name_ered,classe))
	   strcpy(app->class_name_ered,"");
     }
     app=app->next;
    }
    return (res);
}
/*---------------------------------------------------------------------------*/
struct list_attr_ered *Insert1(struct list_attr_ered *app,struct list_attr_ered *aux) {
   
 struct list_attr_ered *temp=(struct list_attr_ered *)malloc(sizeof(struct list_attr_ered));    
 temp->class_name_ered = malloc(sizeof(char)*MAX);
 temp->name_attr_ered = malloc(sizeof(char)*MAX);
 temp->type_attr_ered = malloc(sizeof(char)*MAX);
 temp->vector_ered = malloc(sizeof(char)*MAX);
 temp->class_name_ered = aux->class_name_ered;
 temp->name_attr_ered = aux->name_attr_ered;
 temp->type_attr_ered = aux->type_attr_ered;
 temp->vector_ered = aux->vector_ered;
 temp->next = app;
 return (temp);
}
/*---------------------------------------------------------------------------*/
struct list_attr_ered *Insert2(struct list_attr_ered *app,struct list_attr *aux,char *classe) {
   
 struct list_attr_ered *temp=(struct list_attr_ered *)malloc(sizeof(struct list_attr_ered));    
 temp->class_name_ered = malloc(sizeof(char)*MAX);
 temp->name_attr_ered = malloc(sizeof(char)*MAX);
 temp->type_attr_ered = malloc(sizeof(char)*MAX);
 temp->vector_ered = malloc(sizeof(char)*MAX);
 temp->class_name_ered = classe;
 temp->name_attr_ered = aux->name_attr;
 temp->type_attr_ered = aux->type_attr;
 temp->vector_ered = aux->vector;
 temp->next = app;
 return (temp);
}
/*---------------------------------------------------------------------------*/
struct list_attr_ered *Delete_If_Exists(struct list_attr_ered *app,char *nome) {

   struct list_attr_ered *temp=app, *temp1;
   if (!temp) return (temp);
   if (!strcmp(temp->name_attr_ered, nome)) {
    delete(temp->class_name_ered);
    delete(temp->name_attr_ered);
    delete(temp->type_attr_ered);
    delete(temp->vector_ered);
    temp1=app->next;
    delete(temp);
    return(temp1);
   }
   temp1=temp;
   temp=temp->next;
   while(temp) {
     if (!strcmp(temp->name_attr_ered,nome)) {
       temp1->next=temp->next;
       delete(temp->class_name_ered);
       delete(temp->name_attr_ered);
       delete(temp->type_attr_ered);
       delete(temp->vector_ered); 
       delete(temp);
       break;
     }
     temp1=temp;
     temp=temp->next;
   }
   return(app);
}

/*---------------------------------------------------------------------------*/
int Control_Multiple_Eredity() {
    
    int res=0,count;
    struct eredity *aux = my_class[num_class].super_class;
    struct list_attr_ered *app_elem=NULL,*app_punt=NULL,*app;
    struct list_attr *temp;
    
    while(aux) {                                    /* per ogni superclasse */ 
       count = Ind_From_Class(aux->name);
       app = my_class[count].temp_ered_elem;
       
	/* considero tutti gli attributi che sono gia' nella lista temporanea 
	 degli attributi che devono essere ereditati dalla 
	 sottoclasse considerata rispetto a quelli
	 che sono ereditati dalla superclasse che si sta considerando (aux)*/
	 
       while (app) {                         
	 if (Not_Exists(app_elem,app->name_attr_ered,app->class_name_ered))
	      app_elem= Insert1(app_elem,app);
	 app=app->next;
       } 
       
       /* considero tutti gli attributi che sono gia' nella lista temporanea 
	 degli attributi che devono essere ereditati dalla 
	 sottoclasse considerata rispetto a quelli
	 che sono definiti nella superclasse che si sta considerando (aux)*/
	 
      temp = my_class[count].temp_elem;
      while (temp) {
	if ((temp->pblc ==1) &&
	(Not_Exists(app_elem,temp->name_attr,my_class[count].class_name)))
	    app_elem= Insert2(app_elem,temp,my_class[count].class_name);
	temp = temp->next;
      }
    /*analogo a prima per la lista degli attributi speciali */
      app = my_class[count].temp_ered_punt;
	 
       while (app) {                         
	 if (Not_Exists(app_punt,app->name_attr_ered,app->class_name_ered))
	      app_punt= Insert1(app_punt,app);
	 app=app->next;
       } 
      temp = my_class[count].temp_punt;
      while (temp) {
	if (Not_Exists(app_punt,temp->name_attr,my_class[count].class_name))
	    app_punt= Insert2(app_punt,temp,my_class[count].class_name);
	temp = temp->next;
    }



    temp = my_class[num_class].temp_elem;
    while (temp) {
      app_elem = Delete_If_Exists(app_elem,temp->name_attr);
      temp=temp->next;
    }
    temp = my_class[num_class].temp_punt;
    while (temp) {
      app_punt = Delete_If_Exists(app_punt,temp->name_attr);
      temp=temp->next;
    }
    
    aux=aux->succ;
 }
    
    
    app=app_elem;
    while(app) {
      if(!strcmp(app->class_name_ered,"")) {
	res = 1;
	printf ("ERRORE!\n");
	printf ("L'attributo %s deve essere ridefinito nella classe %s\n",
		 app->name_attr_ered,my_class[count].class_name);
	printf ("poiche' e' stato precedentemente definito in due sue superclassi\n"); 
      }
      app = app->next;
   }
   app=app_punt;
    while(app) {
      if(!strcmp(app->class_name_ered,"")) {
	res = 1;
	printf ("ERRORE!\n");
	printf ("L'attributo %s deve essere ridefinito nella classe %s\n",
		 app->name_attr_ered,my_class[count].class_name);
	printf ("poiche' e' stato precedentemente definito in due sue superclassi\n"); 
      }
      app = app->next;
   }
   
   
   if (res) { 
     Dealloca_Liste2(app_elem);
     Dealloca_Liste2(app_punt);
   }
   else { 
     my_class[num_class].temp_ered_elem = app_elem;
     my_class[num_class].temp_ered_punt = app_punt;
   }
   
/*   printf("esco da Control_Multiple_Eredity\n");
*/
   return (res);
}
/*---------------------------------------------------------------------------*/
int Exist_In_Temporal(char *attributo, int number) {

   int res = 0;
   struct list_attr *aux = my_class[number].temp_elem;
   while(aux) {
      if(!strcmp(aux->name_attr, attributo))
	 res = 1;
      aux = aux->next;
   }
   struct list_attr_ered *aux1 = my_class[number].temp_ered_elem;
   while(aux1) {
      if(!strcmp(aux1->name_attr_ered, attributo))
	 res = 1;
      aux1 = aux1->next;
   }
   aux = my_class[number].temp_punt;
   while(aux) {
      if(!strcmp(aux->name_attr, attributo))
	 res = 1;
      aux = aux->next;
   }
   aux1 = my_class[number].temp_ered_punt;
   while(aux1) {
      if(!strcmp(aux1->name_attr_ered, attributo))
	 res = 1;
      aux1 = aux1->next;
   }
   return(res);
}
/*---------------------------------------------------------------------------*/
int Control_Temporal_Eredity() {

   int ind, res = 0;
   struct list_attr *aux = my_class[num_class].list_not_temp;
   struct eredity *app = my_class[num_class].super_class;
    
    
/*   printf("sono in Control_Temporal_Eredity\n");
*/
   while(app) {
      ind = 0;
      while(strcmp(my_class[ind++].class_name, app->name) && 
	    (ind <= MAX_CLASS));
      if(ind == (MAX_CLASS + 1)) {
	 res = 1;
	 printf("La superclasse %s non e' presente nel file!\n\n", app->name);
	 break;
      }
      while(aux) {
	
	 if(Exist_In_Temporal(aux->name_attr, ind - 1)) {
	    res = 1;
	    printf("ERRORE!\n");
	    printf("L'attributo temporale %s della classe %s non puo'\n", 
		   aux->name_attr, app->name);
	    printf("essere ridefinito come non temporale nella classe %s\n\n", 
		   my_class[num_class].class_name);
	 }   
	 aux = aux->next;
      }
      app = app->succ;
   }
   if (!res) res = Control_Multiple_Eredity();
   if (!res) { res = Control_Eredity();
	       if (res) { 
		 printf("ERRORE!\n");
		 printf("Un attributo temporale di una superclasse e' definito come\n");
		 printf("attributo  non temporale in un'altra superclasse\n");
	       }
	     }
   return(res);
}
/*---------------------------------------------------------------------------*/
int main(int argc,char *argv[])
{

   FILE *Infile, *Outfile;
   int i;
   char *parola, *parola1, *file_name, car;

   if (argc != 2) {
      fprintf( stderr,"Specificare nome del file di input\n");
      return 1;
      }
   if (( Infile = fopen(argv[1],"r")) == NULL) {
      fprintf( stderr,"fopen  del file di input fallita \n");
		return 1;
     }
   file_name = strcat(argv[1],"_temp.h");

   if (( Outfile = fopen(file_name,"w")) == NULL)
     { fprintf(stderr,"fopen del file di output fallita \n");
       return 1;
     }
   
   parola = malloc(sizeof(char) * MAX);
   parola1= malloc(sizeof(char) * MAX);
   Insert_struct_date(Outfile);
   car = Get_Symbol(Infile, parola);
   while(car != EOF) { 
/* printf("%s iniziale \n",parola);
*/
      if(!strcmp(parola, "persistent")) { 
	 strcpy(parola1,parola);
	 Get_Symbol(Infile, parola);   /* class */
	 if(!strcmp(parola, "class")) { 
	    my_public = 0;
	    my_class[num_class].exist_one_temporal = 0;
	    my_class[num_class].list_not_temp = NULL;
	    my_class[num_class].temp_elem = NULL;
	    my_class[num_class].temp_punt = NULL;
	    my_class[num_class].temp_ered_elem = NULL;
	    my_class[num_class].temp_ered_punt = NULL;
	    my_class[num_class].super_class = NULL;
	    my_class[num_class].class_name = malloc(sizeof(char) * MAX);
	    car = Get_Symbol(Infile, parola);
	    strcpy(my_class[num_class].class_name, parola);
	    Read_Super_Class(Infile, car);

	    int attr_nome_classe = 0;
	    while(Get_Symbol(Infile, parola) != '(') {
	       if(!strcmp(parola, "public")) {
		  my_public = 1;
		  Get_Symbol(Infile, parola); 
	       }
	       if(!strcmp(parola, "temporal")) { 
		  my_class[num_class].exist_one_temporal = 1;
		  Get_Symbol(Infile, parola);
		  
		  Read_Attrib(Infile, parola,1,&attr_nome_classe);
	       }
	       else 
		  Read_Attrib(Infile, parola,0,&attr_nome_classe);
	      
	    }
	    
	    if(Control_Temporal_Eredity()) {
	    
	       for(i = 0; i < num_class; i++) {
		  Dealloca_Liste(my_class[i].list_not_temp);
		  Dealloca_Liste(my_class[i].temp_elem);
		  Dealloca_Liste(my_class[i].temp_punt);
		  Dealloca_Liste1(my_class[i].super_class);
	       }
	       fclose(Infile);
	       fclose(Outfile);
	       exit(0);
	    }
	    
	    
	    
	    
	    
	    if(my_class[num_class].exist_one_temporal) {
	       if (attr_nome_classe) 
       fprintf(Outfile,"\npersistent class %s;\n\n",my_class[num_class].class_name);
	       Write_Struct(Outfile, my_class[num_class].temp_elem);
	       Write_Struct(Outfile, my_class[num_class].temp_punt);
	    }
	fprintf(Outfile, "persistent class %s", my_class[num_class].class_name);
	    if(my_class[num_class].super_class) 
	       Write_Super_Class(Outfile);
	    fprintf(Outfile, " {\n");
	//    fprintf(Outfile, "\tprivate:\n");
	   if(my_class[num_class].exist_one_temporal)    
		fprintf(Outfile, "\t\tdate is_dead;\n");
	    Write_Private_Attrib(Outfile);
	    fprintf(Outfile, "\tpublic:\n");
	    Write_Attrib(Outfile, my_class[num_class].list_not_temp, 0);
	    if(my_class[num_class].exist_one_temporal) {  
	       Write_Attrib(Outfile, my_class[num_class].temp_elem, 1);
	       Write_Attrib(Outfile, my_class[num_class].temp_punt, 1);
	 
	   /* costruttori / distruttori / metodi */
	
	       do {
	      /* si assume che i costr/distr abbiano "(" come carattere
		 immediatamente successivo
	      */
		  fprintf(Outfile, "\n");
		  if(parola[0] != '~')
		     Write_Construct(Infile, Outfile);
		  else
		     Write_Distruct(Infile, Outfile);
		  car = Get_Symbol(Infile, parola);
/*  printf("nome della parola = %s\n",parola);
    printf("nome del carattere = %c\n",car);
*/
	       } while (car == '(');
	    
	       Construct_Methods(Outfile);
	    
	      
	    }//end if class temporal
	
	    else 
	      
	   fprintf(Outfile, "\t%s( ", parola);
	       
	   if(car == EOF) {
	   
	     fprintf(Outfile, "\n};");
	     break;
	   } 
	   if(my_class[num_class].exist_one_temporal==0)    
	   car = Get_Symbol(Infile, parola); 
	   num_class++;
	 } //end if class
	 else { 
	    fprintf(Outfile, "%s ", parola1);
	    fprintf(Outfile, "%s", parola);
	    car = Get_Symbol(Infile, parola);
	 }

      } //end if persistent
      else {
	 fprintf(Outfile, "%s", parola);
	 while (Separator(car)) { 
	    fputc(car,Outfile);
	    car=getc(Infile);
	 }
	 ungetc(car,Infile);
	
	car = Get_Symbol(Infile, parola);
     }
   } //end while

   for(i = 0; i < num_class; i++) {
      Dealloca_Liste(my_class[i].list_not_temp);
      Dealloca_Liste(my_class[i].temp_elem);
      Dealloca_Liste(my_class[i].temp_punt);
      Dealloca_Liste2(my_class[i].temp_ered_elem);
      Dealloca_Liste2(my_class[i].temp_ered_punt);
      Dealloca_Liste1(my_class[i].super_class);
   }

   fclose(Infile);
   fclose(Outfile);

  return 0;
}





